=== debian/changelog ===
rocm-llvm (6.1.2+dfsg-1~exp2) experimental; urgency=medium

  Team upload.

  [ Christian Kastner ]
  * CI: Drop autopkgtest pinning, deps are in unstable now

  [ Cordell Bloor ]
  * d/control: remove stray comma in maintainer field to fix
    the package information listed on tracker.debian.org.
  * d/control: add perl to hipcc dependencies
  * d/control: add libamdhip64-dev to hipcc recommended packages

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 30 Jun 2025 12:47:43 -0600

rocm-llvm (6.1.2+dfsg-1~exp1) experimental; urgency=medium

  [ Xuanteng Huang ]
  * New upstream 6.1.2
    - This replaces all of src:rocm-compilersupport as well as the compiler
      components of src:rocm-hipamd.
  * Reorganize code layout, strip LLVM code forked by AMD
  * Borrow patch from rocm-hipamd to keep the include path order for hipcc
  * Migrate tests from rocm-hipamd as well to validate HIP code compilation
  * Enable Salsa CI pipeline

 -- Xuanteng Huang <xuanteng.huang@outlook.com>  Tue, 22 Oct 2024 23:36:16 +0200
