=== debian/watch ===
version=4

opts="filenamemangle=s%.*/rocm-@ANY_VERSION@%@PACKAGE@-$1.tar.gz%, searchmode=plain, repack, repacksuffix=+dfsg, dversionmangle=s/[~+](?:dfsg|ds)[0-9]*//g" \
     https://api.github.com/repos/ROCm/llvm-project/tags?per_page=100 \
     https://api.github.com/repos/ROCm/llvm-project/tarball/refs/tags/rocm-@ANY_VERSION@
